<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* $Revision$ */

// Copyright (c) 2002 Author Dany De Bontridder dany@alchimerys.be

/*!\file
 * \brief contains all the constant for this plugin
 */

global $adecimal, $athousand, $aseparator, $aformat_date, $aheader, $a_status,$g_dir_importbank;

$adecimal = array(
    array('value' => 0, 'label' => ' '),
    array('value' => 1, 'label' => ','),
    array('value' => 2, 'label' => '.')
);

$athousand = array(
    array('value' => 0, 'label' => ' '),
    array('value' => 1, 'label' => ','),
    array('value' => 2, 'label' => '.')
);
$aseparator = array(
    array('value' => 1, 'label' => ','),
    array('value' => 2, 'label' => ';'),
    array('value' => 3, 'label' => 'Tabulation')
);
$aformat_date = array(
    array('value' => 1, 'label' => 'DD.MM.YYYY', 'format' => 'd.m.Y'),
    array('value' => 2, 'label' => 'DD/MM/YYYY', 'format' => 'd/m/Y'),
    array('value' => 3, 'label' => 'DD-MM-YYYY', 'format' => 'd-m-Y'),
    array('value' => 4, 'label' => 'DD.MM.YY', 'format' => 'd.m.y'),
    array('value' => 5, 'label' => 'DD/MM/YY', 'format' => 'd/m/y'),
    array('value' => 6, 'label' => 'DD-MM-YY', 'format' => 'd-m-y'),
    array('value' => 7, 'label' => 'YYYY-MM-DD', 'format' => 'Y.m.d')
);
$aheader = array(
    array('value' => -1, 'label' => _('-- Non utilisé --')),
    array('value' => 0, 'label' => _('Date')),
    array('value' => 1, 'label' => _('Montant')),
    array('value' => 2, 'label' => _('Libelle')),
    array('value' => 3, 'label' => _('Numéro opération')),
    array('value' => 4, 'label' => _('Tiers')),
    array('value' => 5, 'label' => _('Info supplémentaire'))
);
$a_status = ["T" => _("Transféré"),
    "N" => _("Nouveau"),
    "D" => _("Effacé"),
    "W" => _("Attente"),
    "E" => _("Erreur")
];

$g_dir_importbank = dirname(__FILE__);

/**
 * @brief load automatically class
 *require_once 'class/bank_item.class.php';
 * require_once 'class/import_bank.class.php';
 * require_once 'bank_constant.php';
 * @param string $class classname to load
 */
function importbank_class_autoloader($class)
{
    global $g_dir_importbank;
    $class = strtolower($class);
    \Noalyss\Dbg::echo_file("autoload  search [$class] ");
    $a_file=[
        'noalyss\import_bank\format_bank_sql'=>'/class/format_bank_sql.class.php',
        'noalyss\import_bank\temp_bank_sql'=>'/table/temp_bank_sql.php',
        'noalyss\import_bank\bank_item'=>'/class/bank_item.class.php',
        'noalyss\import_bank\import_bank'=>'/class/import_bank.class.php',
        'noalyss\import_bank\import_csv'=>'/class/import_csv.class.php',
        'noalyss\import_bank\import_coda'=>'/class/import_coda.class.php',
        'noalyss\import_bank\temp_coda_sql'=>'/table/temp_coda_sql.php',
        'noalyss\import_bank\import_sql'=>'/table/import_sql.php'
    ];

    if ( isset ($a_file[$class]) ) {
        \Noalyss\Dbg::echo_file("autoload  found [$class] ");
        require $g_dir_importbank.$a_file[$class];
    }

}

spl_autoload_register('\importbank_class_autoloader', true);