<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 6/06/24
/*! 
 * \file
 * \brief Import CSV files
 */

namespace Noalyss\Import_Bank;

class Import_CSV extends Import_Bank
{
    /**
     * @brief check that there is no duplicate among header and we have at least the date
     * and the amount
     * @param array of header
     * @return empty string if valid, otherwise error message
     */
    static function is_valid_header($array)
    {
        global $aheader;
        $check = $aheader;
        $error = '';
        $amount = $date = false;
        for ($i = 0; $i < count($array); $i++) {
            $idx = $array[$i];

            if ($idx == -1)
                continue;

            if ($idx == 0)
                $date = true;
            if ($idx == 1)
                $amount = true;
            if (isset($check[$idx + 1]['count'])) {
                $check[$idx + 1]['count']++;
            } else {
                $check[$idx + 1]['count'] = 1;
            }
        }
        if (!$date)
            $error .= _("Il manque la colonne pour les  dates") . " \n";
        if (!$amount)
            $error .= _("Il manque la colonne pour les  montants") . " \n";

        foreach ($check as $row) {
            if ($row['value'] == -1)
                continue;
            if (isset($row['count']) && $row['count'] > 1)
                $error .= $row['label'] . " a été donné " . $row['count'] . " fois\n";
        }
        return $error;
    }
}