<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 29/05/24
/*! 
 * \file
 * \brief import the CODA files, main file
 */
global $g_dir_importbank;
global $cn;
global $version_plugin;
\Noalyss\Dbg::echo_file(__FILE__);
$http = new \HttpInput();

// routing
$action = $http->request("sb");

switch ($action) {
    case "upload_file":
        echo h2("Fichier");
        // upload and save the file
        $import_coda = new \Noalyss\Import_Bank\Import_Coda();
        $a_file = $import_coda->upload_file("coda_file");
        try {
            // import into IMPORTBANK.TEMP_CODA
            $import_id = $import_coda->import_file($a_file);

            // transfer into IMPORTBANK.TEMP_BANK
            $import_coda->transfer_temp_bank(import_id: $import_id);

            // select a ledger
            $jrn_def=Noalyss\Import_Bank\Import_Bank::select_ledger();

            // display info from file
            $info_bank=$import_coda->get_info($import_id);
            if ($info_bank != null) {
                echo '<ol>';
                $nb_dest=count($info_bank['company']);
                for ($i=0;$i<$nb_dest;$i++) {
                    echo '<li>',$info_bank['company'][$i];
                    if (isset ($info_bank['bank_acc'][$i])) {
                        echo $info_bank['bank_acc'][$i];
                    }
                    echo '</li>';
                }
                echo '</ol>';
            }
?>
            <FORM METHOD="POST">
                <?php
                echo _("Enregistrer dans le journal");
                echo $jrn_def->input();
                echo \HtmlInput::array_to_hidden(array('gDossier','ac','plugin_code'), $_GET);
                echo \HtmlInput::hidden("id", $import_id);
                echo \HtmlInput::hidden("sa", "purge");
                echo \HtmlInput::hidden("sb", "coda_save");
                echo \HtmlInput::submit("Enregistrer","Enregistrer");
                ?>
            </FORM>
<?php

        } catch (Exception $e) {
            echo_warning($e->getMessage());
            return;
        }



}
