<?php

/**
 *   This file is part of NOALYSS
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * copyright Dany WM De Bontridder($(YEAR))
 *
 *  $(DATE)
 */

namespace Noalyss\Import_Bank;
/**
 * @file
 * @brief abstract of the table
 */

/**
 * @class
 * @brief  abstract of the table
 * i_format : 0 for CSV , 1 for CODA, 2 for merged import
 */
class Import_SQL extends \Table_Data_SQL
{

    function __construct(\DatabaseCore $p_cn, $p_id = -1)
    {
        $this->table = "importbank.import";
        $this->primary_key = "id";
        /*
         * List of columns
         */
        $this->name = array(
            "id" => "id",
            "i_date"=>"i_date",
            "format_bank_id"=>"format_bank_id",
            "i_format"=>"i_format"

        );
        /*
         * Type of columns
         */
        $this->type = array(
            "id" => "numeric",
            "i_date"=>"date",
            "format_bank_id"=>"numeric",
            "i_format"=>"numeric"
        );


        $this->default = array(
            "id" => "auto",
            "i_date"=>"auto"
        );

        $this->date_format = "DD.MM.YYYY";
        parent::__construct($p_cn, $p_id);
    }


}