<?php

/**
 *   This file is part of NOALYSS
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * copyright Dany WM De Bontridder($(YEAR))
 *
 *  $(DATE)
 */

namespace Noalyss\Import_Bank;

/**
 * @file
 * @brief abstract of the table IMPORTBANK.
 */

/**
 * @class
 * @brief  abstract of the table
 */
class Temp_Coda_SQL extends \Table_Data_SQL
{

    function __construct(\DatabaseCore $p_cn, $p_id = -1)
    {
        $this->table = "importbank.temp_coda";
        $this->primary_key = "c_id";
        /*
         * List of columns
         */
        $this->name = array(
            "c_id" => "c_id",
            "c_type" => "c_type",
            "c_code" => "c_code",
            "c_row" => "c_row",
            "import_id" => "import_id"

        );
        /*
         * Type of columns
         */
        $this->type = array(
            "c_id" => "numeric",
            "c_type" => "char",
            "c_code" => "char",
            "c_row" => "text",
            "import_id" => "numeric"
        );


        $this->default = array(
            "c_id" => "auto"
        );

        $this->date_format = "DD.MM.YYYY";
        parent::__construct($p_cn, $p_id);
    }


}