begin;

CREATE TABLE rapport_advanced.listing_document (
                                                   ld_id bigint GENERATED BY DEFAULT AS IDENTITY,
                                                   bucket_id text NOT NULL,
                                                   ld_filename text NOT NULL,
                                                   ld_mimetype text NULL,
                                                   ld_size numeric NULL,
                                                   listing_id bigint NOT NULL,
                                                   ld_lob oid NULL
);
COMMENT ON TABLE rapport_advanced.listing_document IS 'Document uploaded for listing';

-- Column comments

COMMENT ON COLUMN rapport_advanced.listing_document.ld_id IS 'PK';
COMMENT ON COLUMN rapport_advanced.listing_document.bucket_id IS 'Files uploaded before the mail is submitted';
COMMENT ON COLUMN rapport_advanced.listing_document.ld_filename IS 'filename';
COMMENT ON COLUMN rapport_advanced.listing_document.ld_mimetype IS 'mimetype';
COMMENT ON COLUMN rapport_advanced.listing_document.ld_size IS 'file size';
COMMENT ON COLUMN rapport_advanced.listing_document.listing_id IS 'FK to listing_compute';
COMMENT ON COLUMN rapport_advanced.listing_document.ld_lob IS 'document lob';
insert into rapport_advanced.version_listing values (1,now(),'Send uploaded file');
commit;