<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* $Revision$ */

// Copyright (c) 2002 Author Dany De Bontridder dany@alchimerys.be

/*!\file
 * \brief
 */
namespace  Belgian_Tax;


/**
 *@brief transform a string into an arrau without empty element and  duplicate
 * the array is sorted
 *@param $p_string string containing a comma a separator
 *@return array
 *
 */
function get_array_nodup($p_string) {
  $array=explode(',',$p_string);
  sort($array);
  $array=array_unique($array);
  $result=array();
  foreach ($array as $val) {
    if ( $val == '') continue;
    $result[]=$val;
  }
  $r=join(',',$result);
  return $result;
}

#[\AllowDynamicProperties]
class Ext_Tva_Gen
{
    protected $form_id; //!< form id SQL form.id
  function __construct($p_cn) {
    $this->db=$p_cn;
    $this->form_id=1;
  }
  public function get_parameter($p_string) {
    if ( array_key_exists($p_string,$this->variable) ) {
      $idx=$this->variable[$p_string];
      return $this->$idx;
    }
    else
      throw new \Exception (__FILE__.":".__LINE__.'Erreur attribut inexistant');
  }
  public function set_parameter($p_string,$p_value) {
    if ( array_key_exists($p_string,$this->variable) ) {
      $idx=$this->variable[$p_string];
      $this->$idx=$p_value;
    }
    else
      throw new \Exception (__FILE__.":".__LINE__.'Erreur attribut inexistant');


  }
  public function get_info() {    return var_export(self::$variable,true);  }

  public function save() {
  /* please adapt */
    if (  $this->get_parameter("id") == 0 )
      $this->insert();
    else
      $this->update();
  }

  static function choose_periode($by_year=false) {
    require_once NOALYSS_INCLUDE.'/lib/iradio.class.php';
    $monthly=new \IRadio('periodic');
    $monthly->value=1;

    // month
    $month=new \ISelect('bymonth');
    $array=array ();
    for ($i=0;$i<12;$i++) {
      $array[$i]['value']=$i+1; $array[$i]['label']=sprintf('%02d',($i+1));
    }
    $month->value=$array;
    $monthly->selected=true;
    $str_monthly=$monthly->input();
    $str_month=$month->input();
    // year
    $year = new \IText('year');
    $year->size=4;
    $str_year=$year->input();

    // Tri
    $quater=new \ISelect('byquaterly');
    $array=array();
    for ($i=0;$i<4;$i++) {
      $array[$i]['value']=$i+1; $array[$i]['label']=sprintf('%02d',($i+1));
    }
    $quater->value=$array;
    $quaterly=new \IRadio('periodic');
    $quaterly->value=2;
    $str_quaterly=$quaterly->input();
    $str_quater=$quater->input();

    $str_submit=\HtmlInput::submit('decl',_('Afficher'));
    $str_hidden=\HtmlInput::extension().\dossier::hidden();
    if (isset($_REQUEST['sa']))
      $str_hidden.=\HtmlInput::hidden('sa',$_REQUEST['sa']);
	$str_hidden.=\HtmlInput::request_to_hidden(array('ac'));
    $str_byyear='';
    if ( $by_year == true ) {
      $yearly=new \IRadio('periodic');
      $yearly->value=3;
      $str_byyear=$yearly->input();
    }
    ob_start();
      global $g_tva_parameter;
      require_once $g_tva_parameter['template'].'/form_periode.php';
    $r=ob_get_contents();
    ob_end_clean();
    return $r;
  }

  function blank($p_year,$p_periode,$p_flag_quaterly) {
    // load parameter from myown
//    $own=new \Noalyss_Parameter_Folder($this->db);
//    $this->set_parameter("name",$own->MY_NAME);
//    $this->set_parameter("num_tva",$own->MY_TVA);
//    $this->set_parameter('adress',$own->MY_STREET.",".$own->MY_NUMBER);
//    $this->set_parameter('country',$own->MY_COUNTRY." ".$own->MY_CP." ".$own->MY_COMMUNE);
    $this->set_parameter('flag_periode',$p_flag_quaterly);
    $this->set_parameter('periode_dec',$p_periode);
    $this->set_parameter('exercice',$p_year);

    try {
      $this->verify() ;
    } catch ( \Exception $e) {
      echo $e->getMessage();
      throw $e;
    }
    // by month
    if ( $p_flag_quaterly == 1) {
      // start periode = 01 to 31, $p_periode contains the month
      $per_start="01.".$p_periode.".".$p_year;
      $day=31;
      $per_end="31".".".$p_periode.".".$p_year;
      while ( checkdate($p_periode,$day,$p_year) == false && $day > 25) {
	$day--;
	$per_end=$day.".".$p_periode.".".$p_year;
      }
      if ($day < 28 ) { echo __FILE__.__LINE__." Erreur de date $day"; exit;}
    }

    if ( $p_flag_quaterly == 2 ) {
      // compute start periode
      $per_start=$GLOBALS['quaterly_limit'][$p_periode][0].".".$p_year;
      $per_end=$GLOBALS['quaterly_limit'][$p_periode][1].".".$p_year;

    }
    if ( $p_flag_quaterly == 3 ) {
      // compute start periode
      $per_start='01.01.'.$p_year;
      $per_end='31.12.'.$p_year;
    }

    $this->set_parameter('start_periode',$per_start);
    $this->set_parameter('end_periode',$per_end);

  }

  /**
   *@brief display the information about the company
   */
  function display_info(){
    /* date */

    if (isset($this->date_decl)) { $idate=new \IText('date',format_date($this->date_decl));$str_date=$idate->input();}

    /* periode */

    if ( isset($this->start_date) ){
      $str_start=format_date($this->start_date);
      $str_end=format_date($this->end_date);

    }
    $ianne=$this->exercice;
    $representative=new \Belgian_Tax\XML\Representative();
    $declarant=new \Belgian_Tax\XML\Declarant();
    ob_start();
    global $g_tva_parameter;
    require_once $g_tva_parameter['template'].'/form_decl_info.php';
    echo '<div class="row">';
    echo '<div class="col">';
    echo h2(_("Représentant"),'class="title"');
    $representative->display();
    echo '</div>';
    echo '<div class="col">';
    echo h2(_("Déclarant"),'class="title"');
    $declarant->display();
    echo '</div>';
    echo '</div>';
    $r=ob_get_contents();
    ob_end_clean();
    return $r;
  }
    function menu($array)
    {
        $r="";
        $r .= \Noalyss\Dbg::echo_function(__FUNCTION__, false);
        foreach ($array as $item) {
            $url=$item[0];
            $javascript="";
            $label=$item[1];
            $description=$item[2];

            if ($url == "javascript:void(0)") {
                $javascript=$item[4];
            }
            $r.=<<<EOF
<div class="nav nav-link noprint" style="display:inline">
<a class="line" style="color:#007bff;" href="$url" title="$description" $javascript>$label</a>
</div> 
EOF;

        }
        return $r;

    }
}
