<?php
namespace  Belgian_Tax;
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* $Revision$ */

// Copyright (c) 2002 Author Dany De Bontridder dany@alchimerys.be

/*!\file
 * \brief this file is included to create a  new VAT declaration
 * 
 */

use Belgian_Tax\Ext_Tva;

\Noalyss\Dbg::echo_file(__FILE__);

echo '<div class="content" >';
$http=new \HttpInput();
try {
  $year=$http->request("year","number",date('Y'));
  if ( $year < 2000|| $year >2100) {
  throw new \Exception("Année invalide $year");
  }

} catch (\Exception $e) {
  echo_warning($e->getMessage());
  echo Ext_Tva::choose_periode();
  echo '</div>';
  exit;
}
// verify the year


  // if the periode is not set we have to ask it
if ( ! isset($_REQUEST['decl']) ){
  echo Ext_Tva::choose_periode();
  echo '</div>';
  exit;
}
$cn=\Dossier::connect();
/**************************************************************************
 *Save
 *************************************************************************/
if (isset($_POST['save'] )) {
  $save=new Ext_Tva($cn);
  $save->from_array($_POST);
  $save->insert();
  echo h1(_('Déclaration sauvée'),'class="notice"');
  echo $save->menu();

  echo $save->display();

  echo '</div>';
  exit;
}

$tva=new Ext_Tva($cn);
/**************************************************************************
 * by month
 *************************************************************************/
if ( $_REQUEST['periodic']==1) {
  $str_monthly='';
  $bymonth=$http->get("bymonth","number");
  $str_month=$bymonth;$str_year=$year;$str_quaterly="";$str_hidden='';$str_submit='';$str_quater='-';
  $tva->blank($year,$bymonth,1);

}
/**************************************************************************
* by quater *
 *************************************************************************/
if ($_REQUEST['periodic'] == 2) {
  $str_quaterly='';
  $str_month="-";
  $str_year=$http->get("year","number");
  $str_quater=$http->request('byquaterly');
  $str_hidden='';$str_submit='';$str_monthly='';
  $tva->blank($str_year,$str_quater,2);
}
try {
  $r=$tva->compute();
} catch (\Exception $e) {

  echo '<div class="content" style="width:80%;margin-left:10%">';
  echo Ext_Tva::choose_periode();
  echo '</div>';
  return;
  }
global $g_tva_parameter;
require_once $g_tva_parameter['template'].'/form_periode.php';

echo '<form class="print" method="post" style="margin-left:5rem;margin-right:5rem;">';
echo \Dossier::hidden();
echo \HtmlInput::extension();
echo \HtmlInput::hidden('start_periode',$tva->start_periode);
echo \HtmlInput::hidden('end_periode',$tva->end_periode);
echo \HtmlInput::hidden('flag_periode',$tva->flag_periode);
//echo \HtmlInput::hidden('name',$tva->tva_name);
//echo \HtmlInput::hidden('num_tva',$tva->num_tva);
//echo \HtmlInput::hidden('adress',$tva->adress);
//echo \HtmlInput::hidden('country',$tva->country);
echo \HtmlInput::hidden('exercice',$tva->exercice);


echo $tva->display_info();
echo $r;
echo $tva->display_declaration_amount();
echo \HtmlInput::submit('save',_('Sauvegarde'));
echo '</form>';
echo '</div>';
  // create the XML files and the OD operation, validate it to save it into the vat history


?>
